searchNodes=[{"ref":"Aphora.html","title":"Aphora","type":"module","doc":"This module is the Supervisor for Aphora as well as the main interface for the GenServer in which you can create a Aphora.Worker.aphora_id/0 by using new_id/0."},{"ref":"Aphora.html#new_id/0","title":"Aphora.new_id/0","type":"function","doc":""},{"ref":"Aphora.html#start/2","title":"Aphora.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Aphora.Config.html","title":"Aphora.Config","type":"module","doc":"This module provides a simple interface to the config.exs file, by providing a default variable fallback."},{"ref":"Aphora.Config.html#get_datacenter/0","title":"Aphora.Config.get_datacenter/0","type":"function","doc":"Returns the set unique datacenter/0 identifier from the config, or otherwise the default value 0. Examples iex&gt; Aphora.Config.datacenter() 0"},{"ref":"Aphora.Config.html#get_epoch/0","title":"Aphora.Config.get_epoch/0","type":"function","doc":"Returns the set unique epoch/0 identifier from the config, or otherwise the default value 1_546_300_800_000. Examples iex&gt; Aphora.Config.epoch() 1546300800000000"},{"ref":"Aphora.Config.html#get_worker/0","title":"Aphora.Config.get_worker/0","type":"function","doc":"Returns the set unique worker/0 identifier from the config, or otherwise the default value 0. Examples iex&gt; Aphora.Config.worker() 0"},{"ref":"Aphora.Config.html#t:datacenter/0","title":"Aphora.Config.datacenter/0","type":"type","doc":"This can be any non-negative integer within the span of 0..31 and represents the datacenter/0 in which the worker/0 resides in."},{"ref":"Aphora.Config.html#t:epoch/0","title":"Aphora.Config.epoch/0","type":"type","doc":"This can be any non-negative integer and represents the epoch/0 with which the Aphora.Worker.timestamp/0 is generated. epoch/0 should never be changed after deploying IDs to prevent duplicates."},{"ref":"Aphora.Config.html#t:worker/0","title":"Aphora.Config.worker/0","type":"type","doc":"This can be any non-negative integer within the span of 0..1_023 and represents the unique worker/0 within a datacenter/0. A worker/0 should never be assigned twice with the same ID within the same datacenter/0."},{"ref":"Aphora.Helper.html","title":"Aphora.Helper","type":"module","doc":"This module provides methods, which help to utilize Aphora.Worker.aphora_id/0 correctly, by enabling the en- and decoding as well as the fetching of specific information."},{"ref":"Aphora.Helper.html#decode/1","title":"Aphora.Helper.decode/1","type":"function","doc":""},{"ref":"Aphora.Helper.html#encode/1","title":"Aphora.Helper.encode/1","type":"function","doc":""},{"ref":"Aphora.Worker.html","title":"Aphora.Worker","type":"module","doc":"This module implements a GenServer, which can generate guaranteed unique aphora_id/0 on demand."},{"ref":"Aphora.Worker.html#build_id/1","title":"Aphora.Worker.build_id/1","type":"function","doc":"Returns the unique aphora_id/0. It first combines the binary representation of the information within the state into a 72 Bits binary.Afterwards it gets encoded using Base.url_encode64/2 without a padding, so it can be easily used for any URI. Examples iex&gt; Aphora.Worker.build_id(%{datacenter: 2, worker: 981_207, timestamp: 912_988_800_000_000, counter: 423}) &quot;AAM-W8UboAAAAg741wABpw&quot;"},{"ref":"Aphora.Worker.html#child_spec/1","title":"Aphora.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Aphora.Worker.html#init/1","title":"Aphora.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Aphora.Worker.html#start_link/1","title":"Aphora.Worker.start_link/1","type":"function","doc":""},{"ref":"Aphora.Worker.html#timestamp/1","title":"Aphora.Worker.timestamp/1","type":"function","doc":"Returns the timestamp/0. It gets calculated by taking the current time System.os_time/1 and substracting the Aphora.Config.epoch/0 of it. Examples iex&gt; Aphora.Worker.timestamp(0) == System.os_time(:millisecond) true"},{"ref":"Aphora.Worker.html#t:aphora_id/0","title":"Aphora.Worker.aphora_id/0","type":"type","doc":"A aphora_id/0 is a 72 Bits long unique &amp; sortable identifier, which doesn&#39;t require any centralised coordination. It consists out of: 45 Bits timestamp/0. 5 Bits Aphora.Config.datacenter/0. 10 Bits Aphora.Config.worker/0. 12 Bits counter/0."},{"ref":"Aphora.Worker.html#t:counter/0","title":"Aphora.Worker.counter/0","type":"type","doc":"A counter/0 is a 12 Bits long identifier, which by default has a value of 0. It only increments, if two aphora_id/0 are to be generated within the same timestamp/0. This allows for a total of 4_096 aphora_id/0 to be generated within the same timestamp/0 on the same unique Aphora.Config.worker/0 &amp; Aphora.Config.datacenter/0 combination."},{"ref":"Aphora.Worker.html#t:timestamp/0","title":"Aphora.Worker.timestamp/0","type":"type","doc":"A timestamp/0 is a positive integer, which is equals to the time in which it was generated within timestamp/1. It consists of System.os_time/1 minus the Aphora.Config.epoch/0. It has a total size of 45 Bits within the aphora_id/0 and a millisecond precision.This allows for 35_184_372_088_832 millisecond or around 1115 years of millisecond precision timestamps."}]